#include <stdio.h>
#include <stdlib.h>
//#include <conio.h>
#include <math.h>
#include <assert.h>

//#include <mydef.h>
#define _argc __argc
#define _argv __argv

typedef unsigned int 	u_int;
typedef unsigned char 	u_char;

//********************************************************************
//********************************************************************
const double M_PI=2*asin(1);

const double Fo=100.0;
const double Fd=44100.0;

u_int	 N=Fd/Fo;

u_int		 n_Tpre=0;

//********************************************************************
void	usage()
{
	printf("Usage: mks {out MY_PCM file: Fd=%lf Hz,8bit,mono} {frec Hz} {n_Tpre}\n",Fd);
	exit(0);
}
//********************************************************************
void	read_params()
{
FILE	*fi=fopen("params.cfg","rb");
	assert(fi);
	assert(fscanf(fi,"%lf",&Fo));
	assert(fscanf(fi,"%lf",&Fd));

	N=Fd/Fo;

	fclose(fi);
}

//********************************************************************
//********************************************************************
void	main()
{
	read_params();
	if(_argc!=4)usage();

FILE	*fo=fopen(_argv[1],"wb"); assert(fo);
double	frec;
	assert(sscanf(_argv[2],"%lf",&frec));
	assert(sscanf(_argv[3],"%u",&n_Tpre));

u_int	m_frec=frec/Fo;
u_char  *out=new char[N];

	for(u_int i=0; i<n_Tpre; i++)
	 {
	  u_char	*p=out;
	  for(u_int n=0; n<N; n++)
	   {
		*p=64*sin(2*M_PI*n*m_frec/N);
		*p+=32*cos(2*M_PI*n*(N/6)/N);
		*p+=24*sin(2*M_PI*n*(N/4)/N);

		p++;
	   }
	  assert(fwrite(out,1,N,fo)==N);
	 }

	delete[] out;

	fclose(fo);
}
//********************************************************************
